commit 0fd6ae9b20913ab84d596448e14411eedbd324f9
Author: Kewen Lin <linkw@linux.ibm.com>
Date:   Tue May 28 21:13:40 2024 -0500

    rs6000: Don't clobber return value when eh_return called [PR114846]
    
    As the associated test case in PR114846 shows, currently
    with eh_return involved some register restoring for EH
    RETURN DATA in epilogue can clobber the one which holding
    the return value.  Referring to the existing handlings in
    some other targets, this patch makes eh_return expander
    call one new define_insn_and_split eh_return_internal which
    directly calls rs6000_emit_epilogue with epilogue_type
    EPILOGUE_TYPE_EH_RETURN instead of the previous treating
    normal return with crtl->calls_eh_return specially.
    
            PR target/114846
    
    gcc/ChangeLog:
    
            * config/rs6000/rs6000-logue.cc (rs6000_emit_epilogue): As
            EPILOGUE_TYPE_EH_RETURN would be passed as epilogue_type directly
            now, adjust the relevant handlings on it.
            * config/rs6000/rs6000.md (eh_return expander): Append by calling
            gen_eh_return_internal and emit_barrier.
            (eh_return_internal): New define_insn_and_split, call function
            rs6000_emit_epilogue with epilogue type EPILOGUE_TYPE_EH_RETURN.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/powerpc/pr114846.c: New test.
    
    (cherry picked from commit e5fc5d42d25c86ae48178db04ce64d340a834614)

diff --git a/gcc/config/rs6000/rs6000-logue.cc b/gcc/config/rs6000/rs6000-logue.cc
index a868ede24fb..33077b72611 100644
--- a/gcc/config/rs6000/rs6000-logue.cc
+++ b/gcc/config/rs6000/rs6000-logue.cc
@@ -4283,9 +4283,6 @@ rs6000_emit_epilogue (enum epilogue_type epilogue_type)
 
   rs6000_stack_t *info = rs6000_stack_info ();
 
-  if (epilogue_type == EPILOGUE_TYPE_NORMAL && crtl->calls_eh_return)
-    epilogue_type = EPILOGUE_TYPE_EH_RETURN;
-
   int strategy = info->savres_strategy;
   bool using_load_multiple = !!(strategy & REST_MULTIPLE);
   bool restoring_GPRs_inline = !!(strategy & REST_INLINE_GPRS);
@@ -4763,7 +4760,9 @@ rs6000_emit_epilogue (enum epilogue_type epilogue_type)
 
   /* In the ELFv2 ABI we need to restore all call-saved CR fields from
      *separate* slots if the routine calls __builtin_eh_return, so
-     that they can be independently restored by the unwinder.  */
+     that they can be independently restored by the unwinder.  Since
+     it is for CR fields restoring, it should be done for any epilogue
+     types (not EPILOGUE_TYPE_EH_RETURN specific).  */
   if (DEFAULT_ABI == ABI_ELFv2 && crtl->calls_eh_return)
     {
       int i, cr_off = info->ehcr_offset;
diff --git a/gcc/testsuite/gcc.target/powerpc/pr114846.c b/gcc/testsuite/gcc.target/powerpc/pr114846.c
new file mode 100644
index 00000000000..efe2300b73a
--- /dev/null
+++ b/gcc/testsuite/gcc.target/powerpc/pr114846.c
@@ -0,0 +1,20 @@
+/* { dg-do run } */
+/* { dg-require-effective-target builtin_eh_return } */
+
+/* Ensure it runs successfully.  */
+
+__attribute__ ((noipa))
+int f (int *a, long offset, void *handler)
+{
+  if (*a == 5)
+    return 5;
+  __builtin_eh_return (offset, handler);
+}
+
+int main ()
+{
+  int t = 5;
+  if (f (&t, 0, 0) != 5)
+    __builtin_abort ();
+  return 0;
+}

